<template>
    <v-select
        :value="value"
        :error-messages="errors"
        :items="stockStatus"
        item-text="name"
        item-value="id"
        :cache-items="true"
        :loading="loading"
        :placeholder="placeholder"
        :hide-details="hideDetails"
        :clearable="clearable"
        @change="onChange"
        outlined
    >
        <template slot="selection" slot-scope="data">
            {{ $t(data.item.name) }}
        </template>
        <template slot="item" slot-scope="data">
            {{ $t(data.item.name) }}
        </template>
    </v-select>
</template>

<script>
    export default {
        name: "VStockStatusSelect",
        props: {
            value: {
                required: true,
                default: null
            },
            errors: [String, Array],
            placeholder: {
                type: String,
                default: ''
            },
            hideDetails: {
                type: [Boolean, String],
                default: false
            },
            clearable: {
                type: Boolean,
                default: false
            }
        },
        data: () => ({
            loading: true,
            stockStatus: []
        }),

        mounted() {
            axios.get('api/stocks/status')
                .then(({ data }) => {
                    this.loading = false;
                    this.stockStatus = data;
                })
                .catch(error => {
                    this.loading = false;
                    console.error('Request failed. Returned status of', error.response.status);
                })
        },

        methods: {
            onChange(val) {
                this.$emit('input', val);
            }
        }
    }
</script>

<style scoped>

</style>
